import { Style, Theme } from "../constant/theme";
export declare namespace base {
    class Point {
        x: number;
        y: number;
        constructor(x?: number, y?: number);
        add(p: Point): Point;
        sub(p: Point): Point;
        multy(p: Point): number;
        distance(p: Point): number;
        static distance(x1: number, y1: number, x2: number, y2: number): number;
        clone(): Point;
    }
    class Rect {
        x: number;
        y: number;
        width: number;
        height: number;
        constructor(x?: number, y?: number, width?: number, height?: number);
        set(x?: number, y?: number, width?: number, height?: number): void;
        readonly left: number;
        readonly right: number;
        readonly top: number;
        readonly bottom: number;
        readonly centerX: number;
        readonly centerY: number;
        contain(p: Point): boolean;
        contain2(x: number, y: number): boolean;
        clone(): Rect;
    }
    class Box {
        private cmp;
        constructor(cmp: Component);
        readonly sx: number;
        readonly sy: number;
        readonly psx: number;
        readonly psy: number;
        readonly left: number;
        readonly top: number;
        readonly width: number;
        readonly height: number;
        readonly bottom: number;
        readonly right: number;
        contain(p: Point): boolean;
        contain2(x: number, y: number): boolean;
    }
    class Component extends Rect {
        children: Array<Component>;
        bgColor: string;
        scaleX: number;
        scaleY: number;
        radius: number;
        parent?: Component;
        overflow: boolean;
        active: boolean;
        visible: boolean;
        box: Box;
        borderWith: number;
        borderColor: string;
        constructor(x?: number, y?: number, width?: number, height?: number);
        setStyle(style: Style): void;
        release(): void;
        protected init(): void;
        tryActive(p: Point): void;
        addChild(child: Component, index?: number): void;
        removeChild(child: Component): void;
        removeChildAt(index: number): void;
        childAt(index: number): Component;
        onResize(): void;
        getScaleX(c?: Component): number;
        getScaleY(c?: Component): number;
        getBound(left: number, top: number, width: number, height: number): Rect;
        onDettach(): void;
        onDestroy(): void;
        onDraw(context: CanvasRenderingContext2D): void;
    }
    abstract class BaseUI {
        protected container: Component;
        protected data: any;
        protected theme: Theme;
        constructor(container: Component, theme: Theme);
        addChild(cmp: Component): void;
        removeChile(cmp: Component): void;
        resize(width: number, height: number): void;
        setData(data: any): void;
        onDraw(context: CanvasRenderingContext2D): void;
        readonly width: number;
        readonly height: number;
        setTheme(theme: Theme): void;
        hide(): void;
        show(): void;
        onResize(): void;
    }
}
