export declare namespace event {
    const TOUCH: string;
    const TOUCH_UP: string;
    const TOUCH_DOWN: string;
    const TOUCH_MOVE: string;
    const TOUCH_SCALE: string;
    type EventCbk = (e: EventObject) => void;
    interface TouchData {
        x: number;
        y: number;
        detailX: number;
        detailY: number;
        oldX: number;
        oldY: number;
        x0: number;
        y0: number;
    }
    interface EventObject {
        type: string;
        target: any;
        data: any;
        cbk: EventCbk;
    }
    function bind(type: string, cbk: EventCbk, target: any): void;
    function emit(type: string, data?: any): void;
    function emitComponent(type: string, data?: any): void;
    function cancel(type: string, cbk: EventCbk, target: any): void;
    function cancelAll(): void;
}
