"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function clone(data) {
    if (!data)
        return undefined;
    var d = JSON.parse(JSON.stringify(data));
    for (var key in data) {
        if (typeof data[key] === "function") {
            d[key] = data[key];
        }
    }
    return d;
}
exports.clone = clone;
function isString(data) {
    return typeof data === "string";
}
exports.isString = isString;
function isNumber(data) {
    return typeof data === "number";
}
exports.isNumber = isNumber;
function isArray(data) {
    return Array.isArray(data);
}
exports.isArray = isArray;
function isBool(data) {
    return typeof data === "boolean";
}
exports.isBool = isBool;
function isFunction(data) {
    return typeof data === "function";
}
exports.isFunction = isFunction;
function copyCss(cmp, css) {
    if (!cmp || !css)
        return;
    for (var key in css) {
        cmp[key] = css;
    }
}
exports.copyCss = copyCss;
function drawRoundRect(cxt, x, y, width, height, radius) {
    cxt.beginPath();
    cxt.arc(x + radius, y + radius, radius, Math.PI, Math.PI * 3 / 2);
    cxt.lineTo(width - radius + x, y);
    cxt.arc(width - radius + x, radius + y, radius, Math.PI * 3 / 2, Math.PI * 2);
    cxt.lineTo(width + x, height + y - radius);
    cxt.arc(width - radius + x, height - radius + y, radius, 0, Math.PI * 1 / 2);
    cxt.lineTo(radius + x, height + y);
    cxt.arc(radius + x, height - radius + y, radius, Math.PI * 1 / 2, Math.PI);
    cxt.closePath();
}
exports.drawRoundRect = drawRoundRect;
//# sourceMappingURL=util.js.map