export interface Style {
    borderColor: string;
    lineColor?: string;
    textColor?: string;
    indexColor?: string;
    blackColor?: string;
    whiteColor?: string;
    barColor?: string;
    hitColor?: string;
    bgBarColor?: string;
    blockColor?: string;
    bgColor: string;
}
export interface StyleItem extends Style {
    item: Style;
}
export interface ThemeUI {
    body: StyleItem;
    header: Style;
    left: StyleItem;
}
export interface ThemeDUI {
    body: Style;
    header: Style;
    left: Style;
    closeBtn: Style;
}
export interface Theme {
    DEFAULT_BG_COLOR: string;
    DEFAULT_BORDER_COLOR: string;
    style: Style;
    ui: ThemeUI;
    dui: ThemeDUI;
    name: string;
}
export declare var theme: {
    cur: Theme;
};
export declare var ThemeConfig: {
    default: Theme;
    blue: Theme;
    black: Theme;
    light: Theme;
};
