"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var color_1 = require("./color");
var defaultTheme = {
    DEFAULT_BG_COLOR: color_1.Color.WHITE,
    DEFAULT_BORDER_COLOR: color_1.Color.BLACK,
    style: {
        borderColor: color_1.Color.BLACK,
        bgColor: color_1.Color.WHITE,
    },
    name: "default",
    ui: {
        body: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.WHITE,
            barColor: color_1.Color.BLACK,
            indexColor: color_1.Color.RED,
            bgBarColor: color_1.Color.WHITE,
            lineColor: color_1.Color.BLACK,
            item: {
                borderColor: color_1.Color.BLACK,
                bgColor: color_1.Color.WHITE,
                textColor: color_1.Color.BLACK,
                lineColor: color_1.Color.BLACK
            }
        },
        header: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.WHITE,
            textColor: color_1.Color.BLACK,
            indexColor: color_1.Color.RED,
            lineColor: color_1.Color.BLACK,
        },
        left: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.WHITE,
            item: {
                borderColor: color_1.Color.BLACK,
                bgColor: color_1.Color.WHITE,
                textColor: color_1.Color.BLACK,
            }
        },
    },
    dui: {
        body: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.WHITE,
            barColor: color_1.Color.BLACK,
            indexColor: color_1.Color.RED,
            bgBarColor: color_1.Color.WHITE,
            blockColor: color_1.Color.BLACK,
            lineColor: color_1.Color.GREY21,
        },
        header: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.WHITE,
            textColor: color_1.Color.BLACK,
            indexColor: color_1.Color.RED,
            lineColor: color_1.Color.BLACK,
            hitColor: color_1.Color.RED,
        },
        left: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.WHITE,
            textColor: color_1.Color.BLACK,
            blackColor: color_1.Color.BLACK,
            whiteColor: color_1.Color.WHITE,
            hitColor: color_1.Color.RED,
        },
        closeBtn: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.WHITE,
            textColor: color_1.Color.BLACK,
        }
    }
};
var blueTheme = {
    DEFAULT_BG_COLOR: color_1.Color.WHITE,
    DEFAULT_BORDER_COLOR: color_1.Color.BLACK,
    style: {
        borderColor: color_1.Color.WHITE,
        bgColor: color_1.Color.LIGHTSKYBLUE4,
    },
    name: "blue",
    ui: {
        body: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.SLATEGREY,
            barColor: color_1.Color.SLATEGRAY3,
            indexColor: color_1.Color.DARKORANGE1,
            bgBarColor: color_1.Color.LIGHTSTEELBLUE1,
            lineColor: color_1.Color.GAINSBORO,
            item: {
                borderColor: color_1.Color.LIGHTSTEELBLUE1,
                bgColor: color_1.Color.SLATEGREY,
                textColor: color_1.Color.WHITE,
                lineColor: color_1.Color.GAINSBORO
            }
        },
        header: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.LIGHTSKYBLUE4,
            textColor: color_1.Color.WHITE,
            indexColor: color_1.Color.DARKORANGE1,
            lineColor: color_1.Color.WHITE,
        },
        left: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.LIGHTSKYBLUE4,
            item: {
                borderColor: color_1.Color.LIGHTSTEELBLUE1,
                bgColor: color_1.Color.LIGHTSKYBLUE4,
                textColor: color_1.Color.WHITE,
            }
        },
    },
    dui: {
        body: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.SLATEGREY,
            barColor: color_1.Color.SLATEGRAY3,
            indexColor: color_1.Color.DARKORANGE1,
            bgBarColor: color_1.Color.LIGHTSTEELBLUE1,
            lineColor: color_1.Color.GAINSBORO,
            blockColor: color_1.Color.LIGHTCYAN,
            hitColor: color_1.Color.POWDERBLUE,
        },
        header: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.LIGHTSKYBLUE4,
            textColor: color_1.Color.WHITE,
            indexColor: color_1.Color.DARKORANGE1,
            lineColor: color_1.Color.WHITE,
        },
        left: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.GAINSBORO,
            textColor: color_1.Color.BLACK,
            blackColor: color_1.Color.BLACK,
            whiteColor: color_1.Color.GAINSBORO,
            hitColor: color_1.Color.POWDERBLUE,
            indexColor: color_1.Color.DARKSLATEGRAY,
        },
        closeBtn: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.LIGHTSKYBLUE4,
            textColor: color_1.Color.GAINSBORO,
        }
    }
};
var blackTheme = {
    DEFAULT_BG_COLOR: color_1.Color.WHITE,
    DEFAULT_BORDER_COLOR: color_1.Color.BLACK,
    style: {
        borderColor: color_1.Color.WHITE,
        bgColor: color_1.Color.GREY11,
    },
    name: "black",
    ui: {
        body: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.GREY21,
            barColor: color_1.Color.GREY51,
            indexColor: color_1.Color.GREEN,
            bgBarColor: color_1.Color.GRAY81,
            lineColor: color_1.Color.GAINSBORO,
            item: {
                borderColor: color_1.Color.GRAY91,
                bgColor: color_1.Color.GREY21,
                textColor: color_1.Color.WHITE,
                lineColor: color_1.Color.GAINSBORO
            }
        },
        header: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.GREY11,
            textColor: color_1.Color.GRAY91,
            indexColor: color_1.Color.GREEN,
            lineColor: color_1.Color.WHITE,
        },
        left: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.GREY11,
            item: {
                borderColor: color_1.Color.GAINSBORO,
                bgColor: color_1.Color.GREY11,
                textColor: color_1.Color.GRAY91,
            }
        },
    },
    dui: {
        body: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.GREY21,
            barColor: color_1.Color.GREY51,
            indexColor: color_1.Color.GREEN,
            bgBarColor: color_1.Color.GRAY81,
            lineColor: color_1.Color.GAINSBORO,
            blockColor: color_1.Color.GRAY81,
            hitColor: color_1.Color.GREEN4,
        },
        header: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.GREY11,
            textColor: color_1.Color.WHITE,
            indexColor: color_1.Color.GREEN,
            lineColor: color_1.Color.WHITE,
        },
        left: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.GAINSBORO,
            textColor: color_1.Color.BLACK,
            blackColor: color_1.Color.BLACK,
            whiteColor: color_1.Color.GAINSBORO,
            hitColor: color_1.Color.GREEN4,
            indexColor: color_1.Color.GREEN4,
        },
        closeBtn: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.LIGHTSKYBLUE4,
            textColor: color_1.Color.GAINSBORO,
        }
    }
};
var lightTheme = {
    DEFAULT_BG_COLOR: color_1.Color.WHITE,
    DEFAULT_BORDER_COLOR: color_1.Color.BLACK,
    style: {
        borderColor: color_1.Color.GAINSBORO,
        bgColor: color_1.Color.WHITE,
    },
    name: "light",
    ui: {
        body: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.WHITE,
            barColor: color_1.Color.GRAY81,
            indexColor: color_1.Color.BLUE1,
            bgBarColor: color_1.Color.WHITE,
            lineColor: color_1.Color.GAINSBORO,
            item: {
                borderColor: color_1.Color.GRAY91,
                bgColor: color_1.Color.WHITE,
                textColor: color_1.Color.ROYALBLUE1,
                lineColor: color_1.Color.GREY61
            }
        },
        header: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.WHITE,
            textColor: color_1.Color.GREY51,
            indexColor: color_1.Color.BLUE1,
            lineColor: color_1.Color.GAINSBORO,
        },
        left: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.WHITE,
            item: {
                borderColor: color_1.Color.GAINSBORO,
                bgColor: color_1.Color.WHITE,
                textColor: color_1.Color.GREY51,
            }
        },
    },
    dui: {
        body: {
            borderColor: color_1.Color.BLACK,
            bgColor: color_1.Color.WHITE,
            barColor: color_1.Color.GRAY81,
            indexColor: color_1.Color.BLUE1,
            bgBarColor: color_1.Color.WHITE,
            lineColor: color_1.Color.GAINSBORO,
            blockColor: color_1.Color.GREY61,
            hitColor: color_1.Color.LIGHTSTEELBLUE,
        },
        header: {
            borderColor: color_1.Color.GAINSBORO,
            bgColor: color_1.Color.WHITE,
            textColor: color_1.Color.GREY51,
            indexColor: color_1.Color.BLUE1,
            lineColor: color_1.Color.GAINSBORO,
        },
        left: {
            borderColor: color_1.Color.GREY61,
            bgColor: color_1.Color.WHITE,
            textColor: color_1.Color.ROYALBLUE1,
            blackColor: color_1.Color.GREY31,
            whiteColor: color_1.Color.GAINSBORO,
            hitColor: color_1.Color.LIGHTSTEELBLUE,
            indexColor: color_1.Color.STEELBLUE,
        },
        closeBtn: {
            borderColor: color_1.Color.GREY51,
            bgColor: color_1.Color.ALICEBLUE,
            textColor: color_1.Color.GREY51,
        }
    }
};
exports.theme = {
    cur: defaultTheme,
};
exports.ThemeConfig = {
    default: defaultTheme,
    blue: blueTheme,
    black: blackTheme,
    light: lightTheme
};
//# sourceMappingURL=theme.js.map