"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Midi = require('@tonejs/midi').Midi;
var Tone = require('tone/Tone');
var base_1 = require("./base/base");
var ui_1 = require("./ui/ui");
var event_1 = require("./base/event");
var util_1 = require("./base/util");
var dui_1 = require("./dui/dui");
var config_1 = require("./constant/config");
var theme_1 = require("./constant/theme");
var MidiView = (function () {
    function MidiView(view, key) {
        this.eobj = { x: 0, y: 0, detailX: 0, detailY: 0, oldX: 0, oldY: 0, x0: 0, y0: 0 };
        this.active = false;
        this.keysMap = {};
        this.synths = [];
        this.startTime = 0;
        this.bpm = 2;
        this.bindListner = [];
        this.view = view;
        this.canvas = this.view.querySelector("canvas");
        if (!this.canvas) {
            this.canvas = document.createElement("canvas");
            this.view.appendChild(this.canvas);
        }
        var ctx = this.canvas.getContext("2d");
        if (ctx) {
            this.context = ctx;
        }
        else {
            throw "unsupport canvas 2d";
        }
        this.container = new base_1.base.Component();
        this.container.borderWith = config_1.config.DEFAULT_BMP;
        this.container.borderColor = "#cccccc";
        this.container.parent = new base_1.base.Component();
        if (key && theme_1.ThemeConfig[key]) {
            theme_1.theme.cur = theme_1.ThemeConfig[key];
        }
        this.dui = new dui_1.DUI(this.container, theme_1.theme.cur);
        this.dui.hide();
        this.ui = new ui_1.UI(this.container, theme_1.theme.cur);
        this.fit();
        this.bind();
        this.container.setStyle(theme_1.theme.cur.style);
    }
    MidiView.prototype.setTheme = function (key) {
        if (theme_1.ThemeConfig[key]) {
            theme_1.theme.cur = theme_1.ThemeConfig[key];
            this.container.setStyle(theme_1.theme.cur.style);
            this.ui.setTheme(theme_1.theme.cur);
            this.dui.setTheme(theme_1.theme.cur);
            this.refresh();
        }
    };
    MidiView.prototype.refresh = function () {
        this.container.onDraw(this.context);
    };
    MidiView.prototype.addEventListener = function (type, cbk, _thisObj) {
        if (!_thisObj)
            return;
        this.bindListner.push({
            type: type,
            cbk: cbk,
            thisObj: _thisObj,
        });
        _thisObj.addEventListener(type, cbk);
    };
    MidiView.prototype.bind = function () {
        var _this = this;
        this.addEventListener("resize", this.fit.bind(this), window);
        this.addEventListener("mousedown", this.onDown.bind(this), this.canvas);
        this.addEventListener("mousemove", this.onMove.bind(this), this.canvas);
        this.addEventListener("mouseup", this.onUp.bind(this), this.canvas);
        this.addEventListener("mouseout", this.onUp.bind(this), this.canvas);
        this.addEventListener("touchstart", this.onDown.bind(this), this.canvas);
        this.addEventListener("touchmove", this.onMove.bind(this), this.canvas);
        this.addEventListener("touchend", this.onUp.bind(this), this.canvas);
        this.addEventListener("wheel", this.onScroll.bind(this), this.canvas);
        this.addEventListener("keydown", this.onKeyDown.bind(this), document);
        this.addEventListener("keyup", this.onKeyUp.bind(this), document);
        this.addEventListener("position", this.onPosition.bind(this), this.canvas);
        event_1.event.bind("refresh", function (e) {
            _this.refresh();
        }, this);
        event_1.event.bind("show-detail", function (e) {
            _this.ui.hide();
            _this.dui.show();
            _this.dui.setNodesData(e.data);
            _this.refresh();
        }, this);
        event_1.event.bind("hide-detail", function (e) {
            _this.ui.show();
            _this.dui.hide();
            _this.refresh();
        }, this);
    };
    MidiView.prototype.adapteEvent = function (e) {
        if (e.offsetX !== undefined)
            return e;
        if (e["targetTouches"] && e["targetTouches"].length) {
            return {
                offsetX: e["targetTouches"][0].clientX,
                offsetY: e["targetTouches"][0].clientY
            };
        }
        return e;
    };
    MidiView.prototype.onDown = function (eee) {
        var e = this.adapteEvent(eee);
        this.eobj.x = e.offsetX;
        this.eobj.y = e.offsetY;
        this.eobj.x0 = e.offsetX;
        this.eobj.y0 = e.offsetY;
        this.eobj.detailX = 0;
        this.eobj.detailY = 0;
        this.active = true;
        event_1.event.emitComponent(event_1.event.TOUCH_DOWN, util_1.clone(this.eobj));
        this.refresh();
    };
    MidiView.prototype.onMove = function (eee) {
        var e = this.adapteEvent(eee);
        this.eobj.oldX = this.eobj.x;
        this.eobj.oldY = this.eobj.y;
        this.eobj.x = e.offsetX;
        this.eobj.y = e.offsetY;
        this.eobj.detailX = this.eobj.x - this.eobj.oldX;
        this.eobj.detailY = this.eobj.y - this.eobj.oldY;
        if (this.active) {
            if (base_1.base.Point.distance(this.eobj.x, this.eobj.y, this.eobj.x0, this.eobj.y0) >= 5) {
                event_1.event.emitComponent(event_1.event.TOUCH_MOVE, util_1.clone(this.eobj));
            }
            this.refresh();
        }
    };
    MidiView.prototype.onUp = function (eee) {
        var e = this.adapteEvent(eee);
        this.eobj.oldX = this.eobj.x;
        this.eobj.oldY = this.eobj.y;
        this.eobj.x = e.offsetX;
        this.eobj.y = e.offsetY;
        this.eobj.detailX = this.eobj.x - this.eobj.oldX;
        this.eobj.detailY = this.eobj.y - this.eobj.oldY;
        if (base_1.base.Point.distance(this.eobj.x, this.eobj.y, this.eobj.x0, this.eobj.y0) < 5) {
            event_1.event.emitComponent(event_1.event.TOUCH, util_1.clone(this.eobj));
        }
        event_1.event.emitComponent(event_1.event.TOUCH_UP, util_1.clone(this.eobj));
        this.refresh();
        this.active = false;
    };
    MidiView.prototype.onScroll = function (e) {
        e = e || window.event;
        var detail = (e["wheelDelta"] || e["detail"] || 0) * config_1.config.WHELL_RATE;
        if (this.keysMap["SHIFT"]) {
            this.eobj.detailX = detail;
            this.eobj.detailY = 0;
            event_1.event.emitComponent(event_1.event.TOUCH_MOVE, util_1.clone(this.eobj));
        }
        else if (this.keysMap["ALT"] && this.keysMap["CONTROL"]) {
            this.eobj.detailX = detail;
            this.eobj.detailY = detail;
            event_1.event.emitComponent("scale", util_1.clone(this.eobj));
        }
        else if (this.keysMap["ALT"]) {
            this.eobj.detailX = 0;
            this.eobj.detailY = detail;
            event_1.event.emitComponent("scale", util_1.clone(this.eobj));
        }
        else if (this.keysMap["CONTROL"]) {
            this.eobj.detailX = detail;
            this.eobj.detailY = 0;
            event_1.event.emitComponent("scale", util_1.clone(this.eobj));
        }
        else {
            this.eobj.detailX = 0;
            this.eobj.detailY = detail;
            event_1.event.emitComponent(event_1.event.TOUCH_MOVE, util_1.clone(this.eobj));
        }
        this.refresh();
    };
    MidiView.prototype.onKeyDown = function (e) {
        if (e.altKey) {
            this.keysMap["ALT"] = true;
        }
        if (e.shiftKey) {
            this.keysMap["SHIFT"] = true;
        }
        if (e.ctrlKey) {
            this.keysMap["CONTROL"] = true;
        }
    };
    MidiView.prototype.onKeyUp = function (e) {
        var key = e.key.toUpperCase();
        delete this.keysMap[key];
    };
    MidiView.prototype.onPosition = function (e) {
        debugger;
    };
    MidiView.prototype.fit = function () {
        this.canvas.width = this.view.offsetWidth;
        this.canvas.height = this.view.offsetHeight;
        this.ui.resize(this.canvas.width, this.canvas.height);
        this.dui.resize(this.canvas.width, this.canvas.height);
        this.container.onResize();
        this.refresh();
    };
    Object.defineProperty(MidiView.prototype, "Tone", {
        get: function () {
            return Tone;
        },
        enumerable: true,
        configurable: true
    });
    MidiView.prototype.play = function () {
        var _this = this;
        this.stop();
        var self = this;
        var now = Tone.now() + config_1.config.TONE_DELAY;
        this.startTime = now;
        this.synths = [];
        var _loop_1 = function () {
            var track = this_1.data.tracks[i];
            if (track.notes.length) {
                var synth_1 = new Tone.PolySynth(4, Tone.Synth, {
                    envelope: {
                        attack: 0.02,
                        decay: 0.1,
                        sustain: 0.3,
                        release: 1
                    }
                }).toMaster();
                this_1.synths.push(synth_1);
                track.notes.forEach(function (note) {
                    synth_1.triggerAttackRelease(note.name, note.duration, note.time + now, note.velocity);
                });
            }
        };
        var this_1 = this;
        for (var i = 0; i < this.data.tracks.length; i++) {
            _loop_1();
        }
        this.intervalIndex = setInterval(function () {
            self.ui.position = (Tone.now() - self.startTime) * _this.bpm;
            self.dui.position = (Tone.now() - self.startTime) * _this.bpm;
            self.refresh();
        }, config_1.config.REFRESH_INTERVAL);
    };
    MidiView.prototype.stop = function () {
        while (this.synths.length) {
            try {
                var synth = this.synths.shift();
                synth.dispose();
            }
            catch (e) { }
        }
        if (this.intervalIndex) {
            clearInterval(this.intervalIndex);
            this.intervalIndex = undefined;
        }
    };
    MidiView.prototype.loadData = function () {
        if (this.data) {
            if (this.data["header"]) {
                if (this.data["header"]["tempos"] && this.data["header"]["tempos"][0]) {
                    Tone.Transport.bpm.value = this.data["header"]["tempos"][0]["bpm"];
                    this.bpm = 60 / (this.data["header"]["tempos"][0]["bpm"] || config_1.config.DEFAULT_TEMPOS) * 4;
                }
                else {
                    Tone.Transport.bpm.value = config_1.config.DEFAULT_TEMPOS;
                }
                if (this.data["header"]["ppq"]) {
                    Tone.Transport.PPQ = this.data["header"]["ppq"];
                }
            }
            this.ui.setData(this.data);
            this.dui.setData(this.data);
            this.refresh();
        }
    };
    MidiView.prototype.loadFromUrl = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.stop();
                        _a = this;
                        return [4, Midi.fromUrl(url)];
                    case 1:
                        _a.data = _b.sent();
                        this.loadData();
                        return [2];
                }
            });
        });
    };
    MidiView.prototype.loadFromData = function (bstr) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.data = new Midi(bstr);
                this.loadData();
                return [2];
            });
        });
    };
    MidiView.prototype.destroy = function () {
        this.data = undefined;
        event_1.event.cancelAll();
        for (var key in this.bindListner) {
            try {
                var obj = this.bindListner[key];
                obj.thisObj && obj.thisObj.removeEventListener(obj.type, obj.cbk);
            }
            catch (e) {
                console.error(e);
            }
        }
        this.bindListner = [];
        this.container && this.container.onDestroy();
    };
    return MidiView;
}());
exports.MidiView = MidiView;
//# sourceMappingURL=main.js.map