"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("../base/base");
var item_1 = require("./item");
var config_1 = require("../constant/config");
var Body = (function (_super) {
    __extends(Body, _super);
    function Body(x, y, width, height) {
        if (x === void 0) { x = 0; }
        if (y === void 0) { y = 0; }
        if (width === void 0) { width = 0; }
        if (height === void 0) { height = 0; }
        var _this = _super.call(this, x, y, width, height) || this;
        _this.dw = config_1.config.ui.body.dw;
        _this.paddingRight = config_1.config.ui.body.paddingRight;
        _this.offsetX = 0;
        _this.bate = config_1.config.ui.body.bate;
        _this.bpm = 0;
        _this.position = 0;
        _this.lineWidth = config_1.config.ui.body.lineWidth;
        _this.lineColor = "#000000";
        _this.barColor = "#000000";
        _this.bgBarColor = "#ffffff";
        _this.indexColor = "#ff0000";
        _this.indexWidth = config_1.config.ui.body.indexWidth;
        _this.duration = 0;
        _this.borderWith = 0;
        _this.listView = new item_1.ListView(_this, [], config_1.config.ui.body.listView.itemHeight)
            .cbk(function () {
            var item = new item_1.MidiItem();
            item.dw = _this.dw * _this.bpm;
            return item;
        });
        _this.listView.scrollBarWidth = config_1.config.ui.body.listView.scrollBarWidth;
        return _this;
    }
    Object.defineProperty(Body.prototype, "contentHeight", {
        get: function () {
            return this.listView.contentHeight;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Body.prototype, "contentWidth", {
        get: function () {
            return this.duration * this.bpm * this.dw + this.paddingRight;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Body.prototype, "scrollHeight", {
        get: function () {
            return this.contentHeight - this.height;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Body.prototype, "scrollWidth", {
        get: function () {
            return this.contentWidth - this.width;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Body.prototype, "scrollBarHeight", {
        get: function () {
            return this.height - this.scrollHeight < 10 ? 10 : (this.height - this.scrollHeight);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Body.prototype, "scrollSpeedY", {
        get: function () {
            return (this.height - this.scrollBarHeight) / this.scrollHeight;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Body.prototype, "scrollBarWidth", {
        get: function () {
            return this.width - this.scrollWidth < 10 ? 10 : (this.width - this.scrollWidth);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Body.prototype, "scrollSpeedX", {
        get: function () {
            return (this.width - this.scrollBarWidth) / this.scrollWidth;
        },
        enumerable: true,
        configurable: true
    });
    Body.prototype.setStyle = function (style) {
        _super.prototype.setStyle.call(this, style);
        if (!style)
            return;
        if (style.bgBarColor) {
            this.bgBarColor = style.bgBarColor;
        }
        if (style.barColor) {
            this.barColor = style.barColor;
        }
        if (style.indexColor) {
            this.indexColor = style.indexColor;
        }
        if (style.lineColor) {
            this.lineColor = style.lineColor;
        }
    };
    Body.prototype.setData = function (data) {
        this.listView.setData(data);
        this.listView.offsetY = 0;
        this.listView.offsetX = 0;
        this.offsetX = 0;
        this.position = 0;
        this.dw = config_1.config.ui.body.dw;
        this.listView.refresh();
    };
    Body.prototype.onResize = function () {
        this.listView.refresh();
        _super.prototype.onResize.call(this);
    };
    Body.prototype.onDraw = function (context) {
        if (!this.parent)
            return;
        context.save();
        _super.prototype.onDraw.call(this, context);
        context.restore();
        var box = this.box;
        context.lineWidth = this.lineWidth;
        context.strokeStyle = this.lineColor;
        for (var i = 0; i * this.dw * this.bate + this.offsetX < this.width; i++) {
            context.beginPath();
            context.moveTo(box.left + (this.offsetX + i * this.dw * this.bate) * box.sx, box.top);
            context.lineTo(box.left + (this.offsetX + i * this.dw * this.bate) * box.sx, box.top + box.height);
            context.stroke();
        }
        context.beginPath();
        context.strokeStyle = this.indexColor;
        context.lineWidth = this.indexWidth;
        context.moveTo(box.left + (this.offsetX + this.position * this.dw) * box.sx, box.top);
        context.lineTo(box.left + (this.offsetX + this.position * this.dw) * box.sx, box.top + box.height);
        context.stroke();
        if (this.height < this.contentHeight) {
            context.fillStyle = this.bgBarColor;
            context.fillRect(box.left + box.width * box.sx - config_1.config.DEFAULT_BAR_WIDTH, box.top, config_1.config.DEFAULT_BAR_WIDTH, box.height * box.sy);
            context.beginPath();
            context.strokeStyle = this.barColor;
            context.strokeRect(box.left + box.width * box.sx - config_1.config.DEFAULT_BAR_WIDTH, box.top, config_1.config.DEFAULT_BAR_WIDTH, box.height * box.sy);
            context.stroke();
            context.fillStyle = this.barColor;
            context.fillRect(box.left + box.width * box.sx - config_1.config.DEFAULT_BAR_WIDTH, box.top - this.listView.offsetY * this.scrollSpeedY * box.sy, config_1.config.DEFAULT_BAR_WIDTH, this.scrollBarHeight * box.sy);
        }
        if (this.width < this.contentWidth) {
            context.fillStyle = this.bgBarColor;
            context.fillRect(box.left, box.top + box.height * box.sy - config_1.config.DEFAULT_BAR_WIDTH, box.width * box.sx, config_1.config.DEFAULT_BAR_WIDTH);
            context.beginPath();
            context.strokeStyle = this.barColor;
            context.strokeRect(box.left, box.top + box.height * box.sy - config_1.config.DEFAULT_BAR_WIDTH, box.width * box.sx, config_1.config.DEFAULT_BAR_WIDTH);
            context.stroke();
            context.fillStyle = this.barColor;
            context.fillRect(box.left - this.listView.offsetX * this.scrollSpeedX * box.sx, box.top + box.height * box.sy - config_1.config.DEFAULT_BAR_WIDTH, this.scrollBarWidth * box.sx, config_1.config.DEFAULT_BAR_WIDTH);
        }
    };
    return Body;
}(base_1.base.Component));
exports.Body = Body;
//# sourceMappingURL=body.js.map