import { base } from "../base/base";
import { Style } from "../constant/theme";
export declare class Item extends base.Component {
    protected data: any;
    padding: number;
    recycle: boolean;
    constructor(x?: number, y?: number, width?: number, height?: number);
    setData(data: any): void;
    onDraw(context: CanvasRenderingContext2D): void;
    hit(x: number, y: number): boolean;
    onSelect(): void;
}
export declare class ListView {
    offsetY: number;
    offsetX: number;
    private data;
    itemHeight: number;
    private container;
    views: Array<Item>;
    private createItemCbk?;
    scrollBarWidth: number;
    style?: Style;
    constructor(container: base.Component, data: Array<any>, height: number);
    setStyle(style: Style): void;
    setData(data: Array<any>): void;
    readonly contentHeight: number;
    cbk(createItemCbk: () => Item): ListView;
    refresh(): void;
    hit(x: number, y: number): boolean;
}
export declare class MidiItem extends Item {
    dw: number;
    offsetX: number;
    lineColor: string;
    lineWidth: number;
    textWidth: number;
    textColor: string;
    constructor(x?: number, y?: number, width?: number, height?: number);
    setStyle(style: Style): void;
    onDraw(context: CanvasRenderingContext2D): void;
    onSelect(): void;
}
export declare class HeadInfoItem extends Item {
    textColor: string;
    font: string;
    textWidth: number;
    constructor(x?: number, y?: number, width?: number, height?: number);
    setStyle(style: Style): void;
    onDraw(context: CanvasRenderingContext2D): void;
}
